class SolutionsController < ApplicationController
  before_filter :find_user_and_task, :except => [:edit, :update, :download]

  def index
    render :file => 'app/views/solutions/new.html.erb'
  end

  def new
    if !params[:upload].nil? && !@user.nil? && !@task.nil?
      Solution.saveFile(params[:upload])
      solution=Solution.find_by_user_id_and_task_id(@user.id,@task.id)
      if solution.nil?
        solution = Solution.new
        solution.user_id = @user.id
        solution.task_id = @task.id
        solution.version =0
      end
      solution.version = solution.version + 1
      solution.missing =false
      solution.late = (Time.now > @task.deadline)
      upload=params[:upload]
      solution.file_name=File.basename(upload['file'].original_filename)
      solution.save
      redirect_to :controller => "tasks", :action => "show", :id => @task.id
    end
  end
  
  def edit
    @solution = Solution.find_by_id params[:id]
    @user = @solution.user
    @task = @solution.task
  end
  
  def update
    @solution = Solution.find_by_id params[:id]
    s = params[:solution]
    @solution.comment = s['comment'];
    @solution.save
    redirect_to :controller => "tasks", :id => @solution.task.id
  end
  
  def download
    solution = Solution.find_by_id params[:id]
    if !solution.nil?
      file = "/home/kovacsg/feladat3/public/data/"+solution.file_name
      send_file file
    end
  end
  
  private
  def find_user_and_task
    @user = User.find_by_id(session[:user]) if session[:user]
    @task = Task.find_by_id(params[:id]) if params[:id]
  end
end
